/******************************************************************************
 * sdla_voip.h	
 *
 * Author: 	Alex Feldman  <al.feldman@sangoma.com>
 *
 * Copyright:	(c) 1995-2001 Sangoma Technologies Inc.
 *
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 * ============================================================================
 ******************************************************************************
 */

#ifndef __SDLA_VOIP_H
# define __SDLA_VOIP_H

#ifdef __SDLA_VOIP_SRC
# define EXTERN
#else
# define EXTERN extern
#endif


/*
*******************************************************************************
**			  DEFINES and MACROS
*******************************************************************************
*/
#define WAN_VOIP_ENABLE_INTR	0
#define WAN_VOIP_DISABLE_INTR	1

#define WAN_VOIP_IDLE_FLAG	0x7F
/*
*******************************************************************************
**			  TYPEDEF STRUCTURE
*******************************************************************************
*/
typedef struct wan_voip_ {
	void*			voip;
	struct sk_buff*		tx_skb;
	struct sk_buff_head	rx_free_queue;
	struct sk_buff_head	rx_queue;
	int			max_tx_len;
	int			max_timeslots;
	unsigned long		timeslot_map;
} wan_voip_t;

/*
*******************************************************************************
**			  FUNCTION PROTOTYPES
*******************************************************************************
*/
/* interrupt types indicated at 'interrupt_type' byte of the INTERRUPT_INFORMATION_STRUCT */
#define RX_VOIP_INT_PEND				0x01	/* a receive interrupt is pending */
#define TX_VOIP_INT_PEND				0x02	/* a transmit interrupt is pending */

/*
*******************************************************************************
**			  FUNCTION PROTOTYPES
*******************************************************************************
*/
EXTERN int wp_voip_init(void* card, unsigned long, int);
EXTERN void wp_voip_free(wan_voip_t*);
EXTERN int wp_voip_remove(void* voip);
EXTERN int wp_voip_rx_tx(void* card);
EXTERN void wp_voip_report_rbsbits(void* card, int channel, unsigned char status);
EXTERN void wp_voip_report_alarms(void* card, unsigned long te_alarm);

#undef EXTERN
#endif	/* __SDLA_VOIP_H */
